/**
  Comic Book Thumbnailer for KDE 4 v0.1
  Copyright (C) 2009 Harsh J <harsh@harshj.com>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

// comiccreator.h

#ifndef _COMICCREATOR_H_
#define _COMICCREATOR_H_

#include <kio/thumbcreator.h>
#include <kzip.h>

#include <QtCore/QByteArray>
#include <QtCore/QEventLoop>
#if defined(Q_OS_WIN)
    #include <QtCore/QProcess>
#else
    #include <kptyprocess.h>
#endif
#include <QtCore/QStringList>

class ComicCreator : public QObject, public ThumbCreator {
    Q_OBJECT
    public:
        ComicCreator();
        ~ComicCreator();
        virtual bool create(const QString &path, int, int, QImage &img);
            virtual Flags flags() const;

    private:
        QImage *mComicCover;

#if defined(Q_OS_WIN)
        QProcess *mProcess;
#else
        KPtyProcess *mProcess;
#endif
        QByteArray mStdOut;
        QByteArray mStdErr;
        QEventLoop *mLoop;

    private:

        void filterImages(QStringList &entries, const bool sensitive);

        bool extractArchiveImage(QString path, QString type);
        void getArchiveFileList(QStringList &entries, const QString &entry, const KArchiveDirectory* dir);

        bool extractRARImage(QString path);
        bool isUnrarAvailable(QString &unrarPath);
        void getRARFileList(QStringList &entries, const QString path, const QString unrarPath);

//         bool extract7ZImage();
//             void get7ZFileList();
//         bool extractACEImage();
//             void getACEFileList();

        int  startProcess(const QString processPath, QStringList args);

    private Q_SLOTS:

        void readProcessOut();
        void readProcessErr();
        void finishedProcess(int exitCode, QProcess::ExitStatus exitStatus);
};

#endif
